Raritan PX2/PX3 JSON-RPC API: pdumodel::Pdu_4_1_6 Interface Reference

Raritan PX2/PX3 JSON-RPC API

Classes | Public Types | Public Member Functions | Public Attributes | List of all members
pdumodel::Pdu_4_1_6 Interface Reference

Main PDU interface. More...

`import"Pdu.idl";`

## Classes
struct | MetaData
| PDU metadata. More...
struct | OutletSequenceState
| Outlet sequencing status More...
struct | Sensors
| PDU sensors. More...
struct | Settings
| PDU settings. More...
struct | Statistic
| PDU statistics. More...

## Public Types
enum | StartupState { SS_ON, SS_OFF, SS_LASTKNOWN }
| Outlet power state on device startup More...

## Public Member Functions
Nameplate_2_0_0 | getNameplate ()
| Retrieve the PDU nameplate information. More...
MetaData | getMetaData ()
| Retrieve the PDU metadata. More...
Sensors | getSensors ()
| Retrieve the PDU sensors. More...
sensors::Logger_2_1_6 | getSensorLogger ()
| Get the sensor logger. More...
vector< Controller_4_0_1 > | getControllers ()
| Get the list of slave controllers. More...
vector< Outlet_2_1_5 > | getOutlets ()
| Get the list of outlets. More...
vector< OverCurrentProtector_3_0_4 > | getOverCurrentProtectors ()
| Get the list of overcurrent protectors. More...
vector< Inlet_2_0_4 > | getInlets ()
| Get the list of inlets. More...
vector< TransferSwitch_4_0_4 > | getTransferSwitches ()
| Returns list of Transfer Switches. More...
peripheral::DeviceManager_3_0_2 | getPeripheralDeviceManager ()
| Get the peripheral device manager. More...
hmi::InternalBeeper_2_0_1 | getBeeper ()
| Get the built-in beeper, if there is any. More...
Settings | getSettings ()
| Retrieve the PDU settings. More...
boolean | isLoadSheddingActive ()
| Retrieve the current load shedding state. More...
int | setSettings (in Settings settings)
| Change the PDU settings. More...
void | setLoadSheddingActive (in boolean active)
| Enable or disable load shedding. More...
vector< portsmodel::Port_2_0_2 > | getFeaturePorts ()
| Get all feature ports of this device. More...
int | enterRS485ConfigModeAndAssignCtrlBoardAddress (in int addr)
| Enter RS485 config mode and assign an address to a relay board. More...
int | enterRS485ConfigModeAndAssignSCBoardAddress (in int deviceId, in int addr)
| Enter RS485 config mode and assign an address to a slave controller device with a given device ID. More...
int | leaveRS485ConfigMode ()
| Leave RS485 config mode. More...
int | setAllOutletPowerStates (in Outlet_2_1_5::PowerState pstate)
| Switch all outlets. More...
int | setMultipleOutletPowerStates (in vector< int > outletNumbers, in Outlet_2_1_5::PowerState state, in boolean respectSequence)
| Switch multiple outlets. More...
int | cycleAllOutletPowerStates ()
| Power-cycle all outlets. More...
int | cycleMultipleOutletPowerStates (in vector< int > outletNumbers, in boolean respectSequence)
| Power-cycle multiple outlets. More...
Statistic | getStatistic ()
| Retrieve PDU statistics. More...
OutletSequenceState | getOutletSequenceState ()
| Retrieve the current outlet sequencing status. More...
void | cancelOutletSequence ()
| Stop a currently running outlet sequence.

## Public Attributes
constant int | ERR_INVALID_PARAM = 1
| Invalid parameters.
valueobject | SettingsChangedEvent: event::UserEvent { Settings oldSettings
| Event: PDU settings have been changed. More...
Settings | newSettings
| Settings after change.
valueobject | LoadSheddingModeChangedEvent: event::UserEvent { boolean enabled
| Event: Load shedding mode was enabled or disabled. More...
valueobject | OutletSequenceStateChangedEvent: idl::Event { OutletSequenceState newState
| Event: Outlet sequencing state has changed. More...

## Detailed Description

Main PDU interface.

## Member Enumeration Documentation

## ◆ StartupState

enum pdumodel::Pdu_4_1_6::StartupState

Outlet power state on device startup

Enumerator
SS_ON | Outlet will be switched on
SS_OFF | Outlet will be switched off
SS_LASTKNOWN | Restore last known power state.

## Member Function Documentation

## ◆ cycleAllOutletPowerStates()

int pdumodel::Pdu_4_1_6::cycleAllOutletPowerStates | ( |  | ) |

Power-cycle all outlets.

Returns
  0 if OK

## ◆ cycleMultipleOutletPowerStates()

int pdumodel::Pdu_4_1_6::cycleMultipleOutletPowerStates | ( | in vector< int > | outletNumbers,
|  | in boolean | respectSequence
| ) |  |

Power-cycle multiple outlets.

Parameters

  outletNumbers | List of outlet numbers (zero-based)
  respectSequence | `true` to switch in defined sequence order

Returns
  0 if OK
  3 if any of the selected outlets is disabled

## ◆ enterRS485ConfigModeAndAssignCtrlBoardAddress()

int pdumodel::Pdu_4_1_6::enterRS485ConfigModeAndAssignCtrlBoardAddress | ( | in int | addr | ) |

Enter RS485 config mode and assign an address to a relay board.

Warning
  This is dangerous! Do not use except for manufacturing.

Parameters

  addr | New relay board address

Returns
  0 if OK
  1 if any parameters are invalid

## ◆ enterRS485ConfigModeAndAssignSCBoardAddress()

int pdumodel::Pdu_4_1_6::enterRS485ConfigModeAndAssignSCBoardAddress | ( | in int | deviceId,
|  | in int | addr
| ) |  |

Enter RS485 config mode and assign an address to a slave controller device with a given device ID.

Warning
  This is dangerous! Do not use except for manufacturing.

Parameters

  deviceId | Device id of the slave controller board which is supposed to get the address
  addr | New relay board address

Returns
  0 if OK
  1 if any parameters are invalid

## ◆ getBeeper()

hmi::InternalBeeper_2_0_1 pdumodel::Pdu_4_1_6::getBeeper | ( |  | ) |

Get the built-in beeper, if there is any.

Returns
  Beeper interface

## ◆ getControllers()

vector<Controller_4_0_1> pdumodel::Pdu_4_1_6::getControllers | ( |  | ) |

Get the list of slave controllers.

Returns
  List of slave controllers

## ◆ getFeaturePorts()

vector<portsmodel::Port_2_0_2> pdumodel::Pdu_4_1_6::getFeaturePorts | ( |  | ) |

Get all feature ports of this device.

This returns an entry for all feature ports, no matter whether something is connected or not. A device with n feature ports will return n entries here.

Returns
  List of all Feature Ports

## ◆ getInlets()

vector<Inlet_2_0_4> pdumodel::Pdu_4_1_6::getInlets | ( |  | ) |

Get the list of inlets.

Returns
  List of inlets, indexed by their number (zero-based)

## ◆ getMetaData()

MetaData pdumodel::Pdu_4_1_6::getMetaData | ( |  | ) |

Retrieve the PDU metadata.

Returns
  PDU metadata

## ◆ getNameplate()

Nameplate_2_0_0 pdumodel::Pdu_4_1_6::getNameplate | ( |  | ) |

Retrieve the PDU nameplate information.

Returns
  Nameplate information

## ◆ getOutlets()

vector<Outlet_2_1_5> pdumodel::Pdu_4_1_6::getOutlets | ( |  | ) |

Get the list of outlets.

Returns
  List of outlets, indexed by their number (zero-based)

## ◆ getOutletSequenceState()

OutletSequenceState pdumodel::Pdu_4_1_6::getOutletSequenceState | ( |  | ) |

Retrieve the current outlet sequencing status.

Returns
  Sequencing status

## ◆ getOverCurrentProtectors()

vector<OverCurrentProtector_3_0_4> pdumodel::Pdu_4_1_6::getOverCurrentProtectors | ( |  | ) |

Get the list of overcurrent protectors.

Returns
  List of OCPs, indexed by their number (zero-based)

## ◆ getPeripheralDeviceManager()

peripheral::DeviceManager_3_0_2 pdumodel::Pdu_4_1_6::getPeripheralDeviceManager | ( |  | ) |

Get the peripheral device manager.

Returns
  Peripheral device manager

## ◆ getSensorLogger()

sensors::Logger_2_1_6 pdumodel::Pdu_4_1_6::getSensorLogger | ( |  | ) |

Get the sensor logger.

Returns
  Sensor logger reference

## ◆ getSensors()

Sensors pdumodel::Pdu_4_1_6::getSensors | ( |  | ) |

Retrieve the PDU sensors.

Returns
  PDU sensors

## ◆ getSettings()

Settings pdumodel::Pdu_4_1_6::getSettings | ( |  | ) |

Retrieve the PDU settings.

Returns
  PDU settings

## ◆ getStatistic()

Statistic pdumodel::Pdu_4_1_6::getStatistic | ( |  | ) |

Retrieve PDU statistics.

Returns
  PDU statistics

## ◆ getTransferSwitches()

vector<TransferSwitch_4_0_4> pdumodel::Pdu_4_1_6::getTransferSwitches | ( |  | ) |

Returns list of Transfer Switches.

This list may be empty.

## ◆ isLoadSheddingActive()

boolean pdumodel::Pdu_4_1_6::isLoadSheddingActive | ( |  | ) |

Retrieve the current load shedding state.

Returns
  `true` if load shedding is currently enabled

## ◆ leaveRS485ConfigMode()

int pdumodel::Pdu_4_1_6::leaveRS485ConfigMode | ( |  | ) |

Leave RS485 config mode.

Returns
  0 if OK

## ◆ setAllOutletPowerStates()

int pdumodel::Pdu_4_1_6::setAllOutletPowerStates | ( | in Outlet_2_1_5::PowerState | pstate | ) |

Switch all outlets.

Parameters

  pstate | New power state for all outlets

Returns
  0 if OK

## ◆ setLoadSheddingActive()

void pdumodel::Pdu_4_1_6::setLoadSheddingActive | ( | in boolean | active | ) |

Enable or disable load shedding.

Parameters

  active | `true` to enable, `false` to disable load shedding

## ◆ setMultipleOutletPowerStates()

int pdumodel::Pdu_4_1_6::setMultipleOutletPowerStates | ( | in vector< int > | outletNumbers,
|  | in Outlet_2_1_5::PowerState | state,
|  | in boolean | respectSequence
| ) |  |

Switch multiple outlets.

Parameters

  outletNumbers | List of outlet numbers (zero-based)
  state | New power state for all outlets in list
  respectSequence | `true` to switch in defined sequence order

Returns
  0 if OK
  3 if any of the selected outlets is disabled

## ◆ setSettings()

int pdumodel::Pdu_4_1_6::setSettings | ( | in Settings | settings | ) |

Change the PDU settings.

Parameters

  settings | New PDU settings

Returns
  0 if OK
  1 if any parameters are invalid

## Member Data Documentation

## ◆ LoadSheddingModeChangedEvent

valueobject pdumodel::Pdu_4_1_6::LoadSheddingModeChangedEvent

Event: Load shedding mode was enabled or disabled.

Whether load shedding mode is enabled after the change

## ◆ OutletSequenceStateChangedEvent

valueobject pdumodel::Pdu_4_1_6::OutletSequenceStateChangedEvent

Event: Outlet sequencing state has changed.

New sequencing state

## ◆ SettingsChangedEvent

valueobject pdumodel::Pdu_4_1_6::SettingsChangedEvent

Event: PDU settings have been changed.

Settings before change

The documentation for this interface was generated from the following file:

- pdu-json-rpc-api/idl/Pdu.idl